Ruby - Misc #19088

Complex() method with "exception: false' option still raises exception when String argument is in
non-ASCIll-compatible encoding

10/27/2022 07:32 PM - andrykonchin (Andrew Konchin)

Status: Closed
Priority: Normal
Assignee:

Description

I've noticed a minor inconsistency of the Complex() method. When it is called with exception: false option | suppose it shouldn't raise
any exception.

For instance it doesn't raise error in the following cases:

Complex ("1+2ifoobar", exception: false) # => nil
Complex ("14+2i\0", exception: false) # => nil

But it still raises error when argument is in non-ASCII-compatible encoding:

Complex ("1+2i".encode ("UTF-16"), exception: false)
(irb) :4:in "~Complex': ASCII incompatible encoding: UTF-16 (Encoding::CompatibilityError)

| am wondering if exception: false is supposed to suppress this exception as well.

History

#1 - 10/27/2022 07:32 PM - andrykonchin (Andrew Konchin)

- Description updated

#2 - 10/28/2022 11:06 AM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed

exception:false is effective only for the content.
ASCII incompatible encoding strings are not subjects of parsing.

#3 - 10/28/2022 03:53 PM - andrykonchin (Andrew Konchin)
Got it. Thank you.
